QGIS Application - Bug report #9453
ERROR: schema "topology" does not exist
2014-01-29 08:39 AM - Sandro Santilli

Status: Closed

Priority: Normal

Assignee: Sandro Santilli

Category: Data Provider/PostGIS

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 18045
Description

Metadata tables of topology are queried even if topology is not available, resulting in an error.

This is when connecting to a PostGIS database with no topology, error shown in the log.

No idea about possible consequences of that (if any) but it doesn't sound clean to raise an error.

QGIS already checks for topology availability, so has all the information to decide NOT to query topology metadata when topology isn't
available.

This is with current master

Associated revisions

Revision 7456eb79 - 2014-01-29 06:56 PM - Jiirgen Fischer

postgres provider: don't look for topology layers without topology support (fixes #9453)

Revision 673406d2 - 2014-02-03 10:37 AM - Jiirgen Fischer

postgres provider: don't look for topology layers without topology support (fixes #9453)

Revision da4c4292 - 2014-02-03 03:25 PM - Sandro Santilli

Fix query to detect postgis topology availability.

Closes #9453

Revision 8028087 - 2014-02-03 03:28 PM - Sandro Santilli

Fix query to detect postgis topology availability.

Closes #9453

History

#1 - 2014-01-29 10:02 AM - Jurgen Fischer
- Status changed from Open to Closed
Fixed in changeset commit:"7456eb7924edd0a660ca98b3e6d7517bdce2fea8".

#2 - 2014-02-03 02:45 AM - Sandro Santilli
- Status changed from Closed to Reopened

Sorry but | cannot confirm the fix. Could be a problem on my side but as of f45e112 | still see the error:

src/providers/postgres/qgspostgresconn.cpp: 385: (getTablelnfo) getting table info: SELECT I.table_name,l.schema_name,l.feature_column,CASE
WHEN l.feature_type = 1 THEN 'MULTIPOINT' WHEN |.feature_type = 2 THEN '"MULTILINESTRING' WHEN |.feature_type = 3 THEN
'MULTIPOLYGON' WHEN l.feature_type = 4 THEN 'GEOMETRYCOLLECTION' END AS type,(SELECT srid FROM topology.topology t WHERE
|.topology_id=t.id),c.relkind FROM topology.layer |,pg_class c,pg_namespace n WHERE c.relname=l.table_name AND
|.schema_name=n.nspname AND n.oid=c.relnamespace AND has_schema_privilege(n.nspname,'usage’) AND
has_table_privilege("||n.nspname||"."||c.relname||"™,'select’) ORDER BY n.nspname,c.relname,|.feature_column
src/providers/postgres/qgspostgresconn.cpp: 805: (PQexec) Not logged erroneous query: SELECT
|.table_name,l.schema_name,l.feature_column,CASE WHEN |.feature_type = 1 THEN 'MULTIPOINT' WHEN |.feature_type = 2 THEN
'MULTILINESTRING' WHEN l.feature_type = 3 THEN 'MULTIPOLYGON' WHEN l.feature_type = 4 THEN 'GEOMETRYCOLLECTION' END AS
type,(SELECT srid FROM topology.topology t WHERE l.topology_id=t.id),c.relkind FROM topology.layer I,pg_class c,pg_namespace n WHERE
c.relname=l.table_name AND l.schema_name=n.nspname AND n.oid=c.relnamespace AND has_schema_privilege(n.nspname,'usage') AND
has_table_privilege("||n.nspname||"."||c.relname||"™,'select’) ORDER BY n.nspname,c.relname,|.feature_column returned 7 [ERROR: schema
"topology" does not exist

LINE 1: ...pology t WHERE |.topology_id=t.id),c.relkind FROM topology.l...

A

]

WARNING: there is no transaction in progress

#3 - 2014-02-03 04:53 AM - Sandro Santilli
- Assignee set to Sandro Santilli

Found the bug, is in the function checking for topology support:

+ QgsPostgresResult result = PQexec( "SELECT count(c.oid) FROM pg_class AS ¢ JOIN pg_namespace AS n ON c.relnamespace=n.oid WHERE

n.nspname="topology' AND c.relname="topology" );

+

+

+

+

+

if (result.PQntuples() >=1)
{
mTopologyAvailable = true;
}
}

Should indeed be looking at the count, since the query is:

#4 - 2014-02-03 04:54 AM - Sandro Santilli

Besides, may | suggest to look at the "TOPOLOGY" label in output from postgis_full_version() instead ?

#5 - 2014-02-03 04:55 AM - Sandro Santilli
Like this (will test after lunch):

diff --git a/src/providers/postgres/qgspostgresconn.cpp b/src/providers/postgres/qgspostgresconn.cpp
index b4eaf1e..311a0fc 100644
--- a/src/providers/postgres/qgspostgresconn.cpp
+++ b/src/providers/postgres/qgspostgresconn.cpp
@@ -719,17 +719,10 @@ QString QgsPostgresConn::postgisVersion()

{

mProjAvailable = ( proj[0].indexOf( "=1") > -1);

}
-}
- // checking for topology support
- QgsDebugMsg( "Checking for topology support" );
- mTopologyAvailable = false;
- if ( mPostgisVersionMajor > 1)
-
- QgsPostgresResult result = PQexec( "SELECT count(c.oid) FROM pg_class AS ¢ JOIN pg_namespace AS n ON c.relnamespace=n.oid
WHERE n.nspname="topology' AND c.relname="topology™ );
- if (result.PQntuples() >=1)
+ QStringList proj = postgisParts.filter( "TOPOLOGY" );
+ if (proj.size()==1)

{

mTopologyAvailable = true;

+ mTopologyAvailable = ( proj[0].indexOf( "=1") > -1);

#6 - 2014-02-03 06:08 AM - Sandro Santilli

Sorry for the noise, the version string is extracted using "postgis_version()", not "postgis_full_version()", so can't check for TOPOLOGY. Also the

topology.topology trick woudl support pre-2.0 installs of postgis topology which is good.

#7 - 2014-02-03 06:26 AM - Sandro Santilli
- Status changed from Reopened to Closed

Fixed in changeset commit:"da4c4292374d049fde2c238a20a0b726ee9cf48d".

#8 - 2014-02-03 06:30 AM - Sandro Santilli
- Resolution set to fixed/implemented
- % Done changed from 0 to 100

NOTE: backported to 2.0 branch with commit:673406d271fbc54071c3cc8835fb1279e4ebe719 and
commit:f8028087ad533307774c79afceb3580d27466664
